module .exports = [
   {
      category: "angle",
      units: [
         {
            name: "degree",
            conversionFactor: 0.017453292519943295769236907684886127134428718885417254560971,
         },
         {
            name: "gradian",
            conversionFactor: 0.015707963267948966192313216916397514420985846996875529104874,
         },
         {
            name: "radian",
            conversionFactor: 1,
         },
         {
            name: "quadrant",
            conversionFactor: 1.5707963267948966192313216916397514420985846996875529104874,
         },
         {
            name: "revolution",
            conversionFactor: 6.283185307179586476925286766559005768394338798750211641949889,
         },
         {
            name: "semicircle",
            conversionFactor: 3.141592653589793238462643383279502884197169399375105820974944,
         },
      ],
   },
   {
      category: "force",
      units: [
         {
            name: "kilonewton",
            conversionFactor: 1000,
         },
         {
            name: "newton",
            conversionFactor: 1,
         },
         {
            name: "millinewton",
            conversionFactor: 0.001,
         },
         {
            name: "kilopound",
            conversionFactor: 4448.2216152605,
         },
         {
            name: "pound-force",
            conversionFactor: 4.4482216152605,
         },
         {
            name: "millipound",
            conversionFactor: 0.0044482216152605,
         },
         {
            name: "ton-force",
            conversionFactor: 980665000,
         },
         {
            name: "kilogram-force",
            conversionFactor: 980665,
         },
      ],
   },
   {
      category: "length",
      units: [
         {
            name: "kilometre",
            conversionFactor: 1e3,
         },
         {
            name: "metre",
            conversionFactor: 1,
         },
         {
            name: "centimetre",
            conversionFactor: 1e-2,
         },
         {
            name: "millimetre",
            conversionFactor: 1e-3,
         },
         {
            name: "micrometre",
            conversionFactor: 1e-6,
         },
         {
            name: "mile",
            conversionFactor: 1609,
         },
         {
            name: "foot",
            conversionFactor: 0.3048,
         },
         {
            name: "inch",
            conversionFactor: 0.0254,
         },
         {
            name: "milli-inch",
            conversionFactor: 0.0000254,
         },
      ],
   },
   {
      category: "mass",
      units: [
         {
            name: "metric-ton",
            conversionFactor: 1000,
         },
         {
            name: "kilogram",
            conversionFactor: 1,
         },
         {
            name: "gram",
            conversionFactor: 1e-3,
         },
         {
            name: "milligram",
            conversionFactor: 1e-6,
         },
         {
            name: "short-ton",
            conversionFactor: 907.18474,
         },
         {
            name: "short-hundredweight",
            conversionFactor: 45.359237,
         },
         {
            name: "pound",
            conversionFactor: 0.45359237,
         },
         {
            name: "ounce",
            conversionFactor: 0.028349523125,
         },
      ],
   },
]
